package com.testingthought.humble.fixtures.dofixtures;

import fit.DoFixture;
import fit.Parse;
import com.testingthought.humble.ui.InpatientPresenter;
import com.testingthought.humble.ui.PatientDetailPresenter;
import com.testingthought.humble.fixtures.mocks.MockPatientDetailView;
import com.testingthought.humble.fixtures.mocks.MockInpatientView;


public class InteractionDesign extends DoFixture {

    private InpatientPresenter inpatientPresenter;
    private MockInpatientView inpatientView;

    private MockPatientDetailView patientDetailView;
    private PatientDetailPresenter patientDetailPresenter;

    public InteractionDesign() {
        makeAllUIObjects();
        wirePresentersToViews();
        wireViewsToPresenters();
        wirePresentersToPresenters();
    }


    // navigation between contexts
    public void theStartingContextIs(String contextName) {
    }

    public void navigateToTheContext(String contextName) {
    }

    public String theContextBecomes(String ContextName) {
        return "some visibility";
    }

    // inpatient context
    public void choosePatientWithOwner(String animalName, String ownerName) {
        inpatientView.choosePatientWithOwner(animalName, ownerName);
    }

    // patient detail context
    public String thePatientDetailContextNames() {
        return patientDetailView.getPatientName();
    }

    public String thePatientDetailContextShows() {
        return "should return a record";
    }

    public void chooseToEnterANewRecord() {
    }

    public String bothTheContextAndTheContextAre(
            String firstContext, String secondContext) {
        return "some visibility";
    }

    // soap entry context
    public void recordThatTheAnimalIs(
            String threeCharacteristics) {
    }

    public void recordThatItsTemperatureIs(String value) {
    }

    public void indicateThatTheSOAPIsFinished() {
    }


    // Presenter and View wiring

    private void makeAllUIObjects() {
        this.inpatientPresenter = new InpatientPresenter();
        this.patientDetailPresenter = new PatientDetailPresenter();
        this.inpatientView = new MockInpatientView();
        this.patientDetailView = new MockPatientDetailView();
    }

    private void wireViewsToPresenters() {
        this.patientDetailView.setPresenter(patientDetailPresenter);
        this.inpatientView.setPresenter(inpatientPresenter);
    }

    private void wirePresentersToViews() {
        this.inpatientPresenter.setView(inpatientView);
        this.patientDetailPresenter.setView(patientDetailView);
    }

    private void wirePresentersToPresenters() {
        this.inpatientPresenter.setPatientDetailPresenter(patientDetailPresenter);
    }



    // aliases for check - this is a clever hack due
    // to Rick Mugridge.
    public void now(Parse cells) throws Exception {
       check(cells);
    }

    public void noteThat(Parse cells) throws Exception {
        check(cells);
    }
}
